<id>
PageIndex for SP 2.0
</id>

<version>
1.0
</version>

<mod info>

This mod replaces the pageindex in message-index and threads with a select box and previous/next arrows.

Instructions:

Apply this mod.

Upload (in ASCII mode):
Languages/English/Display.lng
Sources/Display.pl
Sources/MessageIndex.pl

</mod info>

<author>
Carsten
</author>

<homepage>
http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl
</homepage>

<edit file>
Languages/English/Display.lng
</edit file>

<search for>
$mdintxt{'3'} = "Delete Selected";
</search for>

<add after>
$pidtxt{'01'} = "all";
</add after>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	# Build the page links list.
	$postdisplaynum = 3;	# max number of pages to display
	$max = $mreplies + 1;
	$start = $INFO{'start'} || 0;
	$start = $start > $mreplies ? $mreplies : $start;
	$start = ( int( $start / $maxmessagedisplay ) ) * $maxmessagedisplay;
	$tmpa = 1;
	$tmpx = int( $max / $maxmessagedisplay );
	if ($start >= (($postdisplaynum-1) * $maxmessagedisplay)) { $startpage = $start - (($postdisplaynum-1) * $maxmessagedisplay); $tmpa = int( $startpage / $maxmessagedisplay ) + 1; }
	if ($max >= $start + ($postdisplaynum * $maxmessagedisplay)) { $endpage = $start + ($postdisplaynum * $maxmessagedisplay); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$scripturl?num=$viewnum/0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxmessagedisplay) { $pageindex = qq~<a href="$scripturl?num=$viewnum/0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?num=$viewnum/$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $maxmessagedisplay;
	$outerpn = int($tmpx / $maxmessagedisplay) + 0;
	$lastpn = int($mreplies / $maxmessagedisplay) + 1;
	$lastptn = ($lastpn - 1) * $maxmessagedisplay;
	if ($endpage < $max - ($maxmessagedisplay) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$scripturl?num=$viewnum/$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;
</search for>

<replace>
$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
		function SelPage(pstart) {
			location.href="$scripturl?num=$viewnum/"+pstart;
		}
	</script>
~;
	# Build the page links list.
	my($pageindex, $all, $allselected);
	$max = $mreplies + 1;
	if ($INFO{'start'} eq "all") { $maxmessagedisplay = $max; $all = 1; $allselected = qq~ selected="selected"~; $start = 0 }
	else { $start = $INFO{'start'} || 0; }
	$start = $start > $mreplies ? $mreplies : $start;
	$start = ( int( $start / $maxmessagedisplay ) ) * $maxmessagedisplay;
	$pagenumb = int(($max - 1) / $maxmessagedisplay) + 1;
	$lastptn = ($pagenumb - 1) * $maxmessagedisplay;
	$pageindex .= qq~<span class="small" style="float: left;"><b>$display_txt{'139'}: $pagenumb &nbsp;</b>~;
	if($pagenumb > 1 || $all) {
		$startpage = 0;
		$prevpage = $start - $maxmessagedisplay;
		$nextpage = $start + $maxmessagedisplay;
		if($start < $maxmessagedisplay) { $pageindex .= qq~<input type="button" value="&#171;" style="font-size: 10px; color: gray; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
		else { $pageindex .= qq~<input type="button" value="&#171;" onclick="SelPage($prevpage)" style="font-size: 10px; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
		$pageindex .= qq~<select style="font-size: 10px; margin-left: 1px; margin-top: 2px;" onchange="if(this.options[this.selectedIndex].value) SelPage(this.options[this.selectedIndex].value)">~;
		for($i=1; $i<=$pagenumb; $i++) {
			$selected = "";
			if($start == $startpage && !$all) { $selected = qq~ selected="selected"~; }
			$pageindex .= qq~<option value="$startpage"$selected>$i</option>~;
			$startpage += $maxmessagedisplay;
		}
		$pageindex .= qq~<option value="all" $allselected>$pidtxt{'01'}</option></select>~;
		if($start >= $lastptn) { $pageindex .= qq~<input type="button" value="&#187;" style="font-size: 10px; color: gray; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
		else { $pageindex .= qq~<input type="button" value="&#187;" onclick="SelPage($nextpage)" style="font-size: 10px; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
	}
	$pageindex .= qq~</span>~;
</replace>

<search for>
$yymain .= qq~$security_txt{'999'}</a></b> $showmods<br />
		       <b>$display_txt{'139'}:</b> $pageindex~;
} else {
$yymain .= qq~<a href="$scripturl?catselect=$curcat" class="nav">$cat</a> &rsaquo;
<a href="$scripturl?board=$currentboard" class="nav">$boardname</a></b> $showmods<br />
		       <b>$display_txt{'139'}:</b> $pageindex~;
</search for>

<replace>
$yymain .= qq~$security_txt{'999'}</a></b> $showmods~;
} else {
$yymain .= qq~<a href="$scripturl?catselect=$curcat" class="nav">$cat</a> &rsaquo;
<a href="$scripturl?board=$currentboard" class="nav">$boardname</a></b> $showmods~;
</replace>

<search for>
    <td valign="middle" align="right" class="catbg" colspan="2">
      $replybutton~;
	 unless(($enable_guestposting == 0 && $iamguest) || $annboard eq $currentboard){
		$yymain .= qq~
		$pollbutton$notify$menusep~;
	}
	$yymain .= qq~
      <a href="$scripturl?action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
      <a href="$scripturl?action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
	</td>
  </tr>
  <tr>
    <td valign="middle" align="left" class="titlebg" colspan="2">
</search for>

<replace>
    <td valign="middle" class="catbg">
      $pageindex
      <span style="float: right;">$replybutton~;
	 unless(($enable_guestposting == 0 && $iamguest) || $annboard eq $currentboard){
		$yymain .= qq~
		$pollbutton$notify$menusep~;
	}
	$yymain .= qq~
      <a href="$scripturl?action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
      <a href="$scripturl?action=print;board=$currentboard;num=$viewnum" target="_blank">$img{'print'}</a>
      </span>
	</td>
  </tr>
  <tr>
    <td valign="middle" align="left" class="titlebg">
</replace>


<search for>
      <td align="right" class="catbg" width="100%" colspan="2">
      $replybutton~;
	 unless(($enable_guestposting == 0 && $iamguest) || $annboard eq $currentboard){
		$yymain .= qq~
		$pollbutton$notify$menusep~;
	}
	$yymain .= qq~
            <a href="$scripturl?board=$currentboard;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$scripturl?board=$currentboard;action=print;num=$viewnum" target="_blank">$img{'print'}</a>
     </td>
  </tr>
</table>
<table border="0" width="100%">
	<tr>
		<td colspan="2">
		<span class="small">
		<b>$display_txt{'139'}: $pageindex<br />
</search for>

<replace>
      <td class="catbg" width="100%">
      $pageindex
      <span style="float: right;">$replybutton~;
	 unless(($enable_guestposting == 0 && $iamguest) || $annboard eq $currentboard){
		$yymain .= qq~
		$pollbutton$notify$menusep~;
	}
	$yymain .= qq~
            <a href="$scripturl?board=$currentboard;action=sendtopic;topic=$viewnum">$img{'sendtopic'}</a>$menusep
            <a href="$scripturl?board=$currentboard;action=print;num=$viewnum" target="_blank">$img{'print'}</a>
      </span>
     </td>
  </tr>
</table>
<table border="0" width="100%">
	<tr>
		<td colspan="2">
		<span class="small">
</replace>


<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
	# Construct the page links for this board.
	$indexdisplaynum = 3;	# max number of pages to display
	$tmpa = 1;
	$tmpx = int( $threadcount / $maxindex );
	if ($start >= (($indexdisplaynum-1) * $maxindex)) { $startpage = $start - (($indexdisplaynum-1) * $maxindex); $tmpa = int( $startpage / $maxindex ) + 1; }
	if ($threadcount >= $start + ($indexdisplaynum * $maxindex)) { $endpage = $start + ($indexdisplaynum * $maxindex); } else { $endpage = $threadcount }
	if ($startpage > 0) { $pageindex = qq~<a href="$scripturl?board=$currentboard/0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxindex) { $pageindex = qq~<a href="$scripturl?board=$currentboard/0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxindex ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?board=$currentboard/$counter">$tmpa</a>&nbsp;~;
		++$tmpa;
	}
	$tmpx = $threadcount - 1 - $maxindex;
	$outerpn = int($tmpx / $maxindex);
	$lastpn = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn = ($lastpn - 1) * $maxindex;
	if ($endpage < $threadcount - $maxindex ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $threadcount) {$pageindexadd .= qq~&nbsp;<a href="$scripturl?board=$currentboard/$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;
</search for>

<replace>
$yymain .= qq~
	<script language="JavaScript1.2" type="text/javascript">
		function SelPage(pstart) {
			location.href="$scripturl?board=$currentboard/"+pstart;
		}
	</script>
~;
	# Construct the page links for this board.
	my($pageindex);
	$pagenumb = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn = ($pagenumb - 1) * $maxindex;
	$pageindex .= qq~<span class="small" style="float: left;"><b>$messageindex_txt{'139'}: $pagenumb &nbsp;</b>~;
	if($pagenumb > 1) {
		$startpage = 0;
		$prevpage = $start - $maxindex;
		$nextpage = $start + $maxindex;
		if($start < $maxindex) { $pageindex .= qq~<input type="button" value="&#171;" style="font-size: 10px; color: gray; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
		else { $pageindex .= qq~<input type="button" value="&#171;" onclick="SelPage($prevpage)" style="font-size: 10px; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
		$pageindex .= qq~<select style="font-size: 10px; margin-left: 1px; margin-top: 2px;" onchange="if(this.options[this.selectedIndex].value) SelPage(this.options[this.selectedIndex].value)">~;
		for($i=1; $i<=$pagenumb; $i++) {
			$selected = "";
			if($start == $startpage) { $selected = qq~ selected="selected"~; }
			$pageindex .= qq~<option value="$startpage"$selected>$i</option>~;
			$startpage += $maxindex;
		}
		$pageindex .= qq~</select>~;
		if($start >= $lastptn) { $pageindex .= qq~<input type="button" value="&#187;" style="font-size: 10px; color: gray; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
		else { $pageindex .= qq~<input type="button" value="&#187;" onclick="SelPage($nextpage)" style="font-size: 10px; padding-left: 1px; padding-right: 1px; margin: 1px; border: 1px; border-style: outset;" />~; }
	}
	$pageindex .= qq~</span>~;
</replace>

<search for>
		     <a href="$scripturl?board=$currentboard" class="nav">$boardname</a></b> $showmods<br />
				<b>$messageindex_txt{'139'}: $pageindex</b>
</search for>

<replace>
		     <a href="$scripturl?board=$currentboard" class="nav">$boardname</a></b> $showmods
</replace>

<search for>
        <td class="catbg" colspan="$colspan" align="right">
			<span class="small">
</search for>

<replace>
        <td class="catbg" colspan="$colspan">
			$pageindex
			<span class="small" style="float: right;">
</replace>

<search for>
    <td class="catbg" colspan="$colspan" align="right">
~;
	if (!$iamguest) {
	$yymain .= qq~<a href="$scripturl?board=$INFO{'board'};action=markasread">$img{'markboardread'}</a>~;
}
	if (&AccessCheck($currentboard, 1) eq "granted"){
		$yymain .= qq~
		$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=$messageindex_txt{'464'}">$img{'newthread'}</a>~;
	}
	if (&AccessCheck($currentboard, 3) eq "granted"){
		$yymain .= qq~
		$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=$messageindex_polltxt{'1a'}">$img{'createpoll'}</a>~;
	}
	$yymain .= qq~
    </td>
</search for>

<replace>
    <td class="catbg" colspan="$colspan">
	$pageindex
	<span class="small" style="float: right;">
~;
	if (!$iamguest) {
	$yymain .= qq~<a href="$scripturl?board=$INFO{'board'};action=markasread">$img{'markboardread'}</a>~;
}
	if (&AccessCheck($currentboard, 1) eq "granted"){
		$yymain .= qq~
		$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=$messageindex_txt{'464'}">$img{'newthread'}</a>~;
	}
	if (&AccessCheck($currentboard, 3) eq "granted"){
		$yymain .= qq~
		$menusep<a href="$scripturl?board=$INFO{'board'};action=post;title=$messageindex_polltxt{'1a'}">$img{'createpoll'}</a>~;
	}
	$yymain .= qq~
	</span>
    </td>
</replace>

<search for>
		<b>$messageindex_txt{'139'}: $pageindex</b><br />
		 <b><a href="$scripturl" class="nav">$mbname</a> &rsaquo; 
</search for>

<replace>
		 <b><a href="$scripturl" class="nav">$mbname</a> &rsaquo; 
</replace>

